"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const postcss_selector_parser_1 = __importDefault(require("postcss-selector-parser"));
const utils_1 = require("./utils");
const plugin = () => {
    return {
        postcssPlugin: 'postcss-typescript-css',
        Root: (root) => {
            var _a;
            const classes = new Set();
            try {
                root.walkRules((rule) => {
                    postcss_selector_parser_1.default((selectors) => {
                        selectors.walkClasses((selector) => {
                            classes.add(selector.value);
                        });
                    }).processSync(rule.selector);
                });
                const cssFileName = (_a = root.source) === null || _a === void 0 ? void 0 : _a.input.file;
                if (!cssFileName)
                    throw root.error('file source is needed');
                utils_1.buildFile(cssFileName, Array.from(classes));
            }
            catch (error) {
                throw root.error(error);
            }
        },
    };
};
plugin.postcss = true;
module.exports = plugin;
